%ext ck1

#Dead Yorp death animations
%patch $1A85 $04
#Dead Yorp death animation start 
%patch $1A8A $5C
%patch $1A37 $03 $00 #Frames used
#Yorp death sound
%patch $1A9C $90
%patch $1BF0 $73 $00 #Shot Garg start sprite
%patch $1BEB $05 $00 #Frames 

#Icecubes inpermanent
%patch $20F3 $51 $21
#Freezes Keen [Used by all four Icecubes at once]
%patch $20D6 $03 $00 
#Up right icecube
%patch $2110 $BF $FF #Up speed
%patch $2115 $40 $00 #Right speed
#Up icecube
%patch $211C $BF $FF #Up speed
#Down icecube
%patch $2128 $40 $00 #Down speed
#Up left icecube
%patch $2134 $BF $FF #Up speed
%patch $2139 $BF $FF #Left speed

#Menu
%patch $15EE9 "New Game"
%patch $15EF6 "Continue Game"
%patch $15F12 "About AvK"
%patch $15F22 "High Scores"
%patch $15F32 "CK Community "
%patch $15F44 "Credits! "
%patch $15F52 "Close Window"

#About ID...
%patch $15F80 "AvK (Aliens versus Keen) was meant"
%patch $15FA8 "to be a 10 min 3Dmovie but during"
%patch $15FD0 "the making of this movie I    "
%patch $15FF8 "learned about mods.."
%patch $16020 "It seemed to be somewhat easy   "
%patch $16048 "to make tiles and sprites, and     "
%patch $16070 "I drew a alien pixel by   "
%patch $16098 "pixel..                "
%patch $160C0 "A week later I found myself  "
%patch $160E8 "with a nearly complete tileset   "
%patch $16110 "and then this came out!"

#Border color
%patch $4A62 $03
%patch $6F9D $03
%patch $15568 $03
%patch $15579 $03
%patch $1558A $03
%patch $1559B $03

%patch $4A7D $03
%patch $4A85 $03

#Title Screen Placement (0,0)
%patch $97B2 $00 $00 # Y location, in pixels
%patch $97B6 $04 $00 # (X location in pixels) / 8 + 4

#Robot does NOT Kill other aliens
%patch $48E9 $04 $00

#Change the controls to: Space, shoot; Enter, status.
%patch $1251  $48
%patch $7FA3  $48
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3DB9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3DCC  $90 $90
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3FFC  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $40AA  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00

#Lets Keen keep keycards when exiting a level:
%patch $4F43  $90 $90 $90 $90 $90 $90 $90 $90
              $90 $90 $90 $90 $90 $90 $90 $90
              $90 $90 $90 $90 $90 $90 $90 $90
              $90 $90 $90 

#CTSpace
%patch $14DEE "You are now cheating!"
%patch $14E05 "You just got a pogo stick,"
%patch $14E21 "all the ID Cards, and "
%patch $14E39 "lots of Fusion-Ray Ammo!"
#CTSpace Cheat Code
#%patch $11F5 0x5040
#%patch $11FC 0x505A
#%patch $1203 0x5048

#Tile info patching script for Keen 1
%patchfile 0x130F8 tileset.tli

#Skip the flight to Earth sequence. [To be cont... shown on background of
#tile No 1] Also skips Mars map and text.
%patch $81A3 $02

#High scores sprite y position
%patch $9879 $00
#'Parts' sprite
%patch $98AB $02
#Scores x offset; $09 puts them where names are, $17 where parts are.]
%patch $99EE $23
#x offset of name [$09 $00 puts names where scores are.]
%patch $9A03 $0F $00
#Name x position [$90 and above drops the sprite one line.]
%patch $988F $0F $00
#'Score' sprites x position [$90 and above drops the sprite one line.]
%patch $98A1 $1D $00
#Parts sprite y position
%patch $98AF $00

#Big versitile status window patch:
# Patch in the long-integer drawing function 
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

# Patch in the name of the status dialog text file, you'll need to create a file with this name and put your status
# text in it or Keen will crash. An example status file can be found in this directory.
%patch $13084  "STATUS.CK1" $00 

# Patch in the code to draw the status text (coordinates are measure in characters--8 pixel blocks) 
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00   # Show status window (0E6A) 
               $CD $21 $89 $C3 $BF $27 $00 $C6 $06 $9A $82 $00 $B9 $0A $00 $BA 
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21 
                                               $8B $46 $FE $05 $01 $00 $50 $89   # Show score (0E98) 
               $F0 $05 $0A $00 $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03 
               $83 $C4 $08 
                           $8B $46 $FE $05 $01 $00 $50 $89 $F0 $05 $1A $00 $50   # Show extra Keen score (0EB3) 
               $A1 $C4 $6E $8B $16 $C2 $6E $81 $C2 $20 $4E $15 $00 $00 $50 $52 
               $E8 $E1 $02 $83 $C4 $08 
                                       $31 $FF $3B $3E $C6 $AA $7D $29 $83 $FF   # Show Keens (0ED6) 
               $06 $7D $24 $B8 $7B $00 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 
               $E0 $90 $90 $50 $89 $F8 $D1 $E0 $05 $01 $00 $01 $F0 $50 $E8 $2C 
               $AC $83 $C4 $06 $47 $EB $D1 
%patch $0F07                               $EB $26 $01 $83 $3E $94 $AA $00 $74   # Draw the joystick 
               $03 $B8 $3D $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $10 $00 $50 $E8 $0D $AA $83 $C4 $06 
                                                                           $EB   # Draw the battery 
               $26 $01 $83 $3E $9C $AA $00 $74 $03 $B8 $3E $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $13 $00 
               $50 $E8 $E5 $A9 $83 $C4 $06 
                                           $EB $26 $01 $83 $3E $96 $AA $00 $74   # Draw the vacuum 
               $03 $B8 $3F $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $16 $00 $50 $E8 $BD $A9 $83 $C4 $06 
                                                                           $EB   # Draw the whiskey 
               $26 $01 $83 $3E $98 $AA $00 $74 $03 $B8 $40 $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $19 $00 
               $50 $E8 $95 $A9 $83 $C4 $06 
%patch $0FA7                               $B8 $91 $01 $83 $3E $9E $AA $00 $74   # Keycard A 
               $03 $B8 $A8 $01 $50 $8B $46 $FE $05 $07 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $6D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard B 
               $91 $01 $83 $3E $A0 $AA $00 $74 $03 $B8 $A9 $01 $50 $8B $46 $FE 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $45 $A9 $83 $C4 $06 
                                           $B8 $91 $01 $83 $3E $A2 $AA $00 $74   # Keycard C 
               $03 $B8 $AA $01 $50 $8B $46 $FE $05 $09 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $1D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard D 
               $91 $01 $83 $3E $A4 $AA $00 $74 $03 $B8 $AB $01 $50 $8B $46 $FE 
               $05 $09 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $F5 $A8 $83 $C4 $06 
%patch $1047                               $B8 $91 $01 $83 $3E $9A $AA $00 $74   # Pogo stick 
               $03 $B8 $9F $01 $50 $8B $46 $FE $05 $08 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $0B $00 $50 $E8 $CD $A8 $83 $C4 $06 
                                                                           $8B   # Draw ammo 
               $46 $FE $05 $0B $00 $50 $89 $F0 $05 $06 $00 $50 $31 $C0 $50 $FF 
               $36 $C8 $AA $E8 $2E $01 $83 $C4 $08 
                                                   $B8 $9E $01 $50 $8B $46 $FE   # Draw raygun (replace first two bytes 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $03 $00   # with $EB $1C if you don't want to 
               $50 $E8 $95 $A8 $83 $C4 $06                                       # draw the raygun on the status screen) 

                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD   # Wait for a key, then return 
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3 

%patch $0EE0 $0C #Maximum number of Keens to show

#First Yorp message: [Level 2] -7 lines
%patch $15080 "Logfile 4479:       "
%patch $15096 "                    "
%patch $150AC "Our researches into "
%patch $150C2 "the aliens continue "
%patch $150D8 "apace; picked up a  "
%patch $150EE "few odd radio signs "
%patch $15104 "near the plateu.    "

#Second Yorp message [level 6] -7 lines
%patch $1511A "Logfile 45314:      "
%patch $15130 "                    "
%patch $15146 "There appears to be "
%patch $1515C "another research    "
%patch $15172 "station near to the "
%patch $15188 "plateu, Lord Mort   "
%patch $1519E "never mentioned it. "

#Third Yorp message: [level 9] -7 lines
%patch $151B4 "Logfile 46912:      "
%patch $151CA "                    "
%patch $151E0 "If ANYONE rEads thi5"
%patch $151F6 "y0u have to fleE!   "
%patch $1520C "the 0th3r statiOn,  "
%patch $15222 "w4z br33d1ng F0r a s"
%patch $15238 "zfqUf sh1ps D3lt!   "

#Fourth Yorp message: [Level 10] -7 lines
%patch $1524E "File: PROPOGATION;  "
%patch $15264 "                    "
%patch $1527A "Live hosts, or even "
%patch $15290 "living tissue do not"
%patch $152A6 "appear as a requiren"
%patch $152BC "pp3689; and we have "
%patch $152D2 "had great sucess in-"

#Fifth Yorp Message: [level 12] -7 lines
%patch $15340 "File: PROPOGATION;  "
%patch $15356 "                    "
%patch $1536C "With a development  "
%patch $15382 "cycle of two days we " #1 longer than usual!
%patch $15399 "have managed to make"
%patch $153AF "inceredible advances"
%patch $153C5 "in the raising of-  "

#Sixth Yorp message: [level 15] -6 lines
%patch $153DB "MISSION FILE:       "
%patch $153F1 "                    "
%patch $15407 "Specimens have been "
%patch $1541D "contained and trans-"
%patch $15433 "ported to storage in"
%patch $15449 "preperation for our-"

#Garg message: [level 11] -4 lines
%patch $152E8 "EMERGENCY PROTOCOL: "
%patch $152FE "                    "
%patch $15314 "Emergency bulkhead  "
%patch $1532A "seal, shoot to close"

#Butler bot initial speed [Both left AND right] until it hits a wall
%patch $17A5  $00 $00
#Butler bot speed [Left AND right] after it hits a wall
%patch $1E31  $FF $FF
#Butler bot doesn't affect Keen
%patch $1782  $02 $00
#Butler bot destructable, spawns a yorp
%patch $17CB $68 $1A
#Butler bot sprite when walking left
%patch $1DD6 $58 $00
#Butler bot sprite when walking right
%patch $1DDE $58 $00

# Switch tiles change to the next in the tileset when flipped 
%patch $36D5 $05 $01 $00 $26 $89 $07 $90 $90 $90 $90 $90 $90 $90 $90 $90

# Change the bridge block in Keen 1 (in this it's changed to tile 480) 
%patch $4AEE $C2 $00
%patch $4B3D $C2 $00

#Sound switch makes when flipped
%patch $35DB $13 $00

%patch $23CD $08 $02 #top l corner
%patch $2436 $09 $02 #top middle
%patch $24B6 $0A $02 #top r corner
%patch $23EF $08 $02 #bottom l corner
%patch $2458 $09 $02 #bottom middle
%patch $24D8 $0A $02 #bottom left
#Change the tiles the block leaves behind
%patch $23AB $08 $02 #left
%patch $2414 $09 $02 #middle
%patch $2494 $0A $02 #right

#Number of 'ticks' block falls [i.e, four ticks of one tile = 4x1 = 4 tile total is standard]
%patch $24E8 $07

#Location of block left end from chain
%patch $238D $F7 $FF
#Location of block right end, from chain, use $FF $FD for -ve values
%patch $2476 $F8 $FF
#Location of middle of block END from chain, number used =
#$FF $FF MINUS [blocks wanted - 5] here FD = FF - [8 - 5]
%patch $23F4 $04 $00

# Disable the "no-clipping" on the map with GOD mode 
%patch $A626  $EB 

#Pogo doesn't fly with Godmode
%patch $3F4E  $EB

#Ice cannon shoot rate
%patch $2058 $08

#Stop 3rd textbox appearing
%patch $8635 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90

#Stop 4th textbox appearing
%patch $867B $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90

#Stop 5th textbox appearing
%patch $86AF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90

#Stop 6th textbox appearing
%patch $86EC $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90

#Stop 7th textbox appearing
%patch $8714 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90
#Skip the flight to Earth sequence. [To be cont... shown on background of
#tile No 1] Also skips Mars map and text.
%patch $81A3 $02

# First dialogue box at home
%patch 0x015CBD "Keen blinks as a flash"
%patch 0x015CD5 "of light surrounds"
%patch 0x015CE9 "him. Huh?        "

%patch 0x015CFB "Then he notices he "
%patch 0x015D10 "is in another room!"
%patch 0x015D25 "Liek, WTF?"

%patch 0x015E07 "Keen stares, he is in"
%patch 0x015E1E "a vast empty room with "
%patch 0x015E37 "a window looking at"
%patch 0x015E4C "the alien planet     "
%patch 0x015E63 "below him.    "

#Keen only has to complete xx+1 levels to win
%patch 0x8020 $83 $BF $A6 $AA $00 $75 $1E $E8 $62 $01 $EB $29

#Exit tiles don't change.
%patch $412E $00

#First Keens house textbox bottom
%patch $8546 $04 $00
#First Keens house textbox top
%patch $854E $00 $00
#Second textbox bottom
%patch $85D5 $04 $00
#Second Keens house textbox top
%patch $85DD $00 $00
#Eighth textbox bottom
%patch $877C $06 $00
#Eighth Keens house textbox top
%patch $8784 $00 $00
#Destroy all pauses
%patch $8586 $10 $00
%patch $85A9 $10 $00
%patch $85CC $10 $00
%patch $8612 $10 $00
%patch $873F $10 $00
%patch $8762 $10 $00
#Destroy all ordering info text
%patch $1632C $00
%patch $16346 $00
%patch $16361 $00
%patch $16379 $00
%patch $16392 $00
%patch $163AD $00
%patch $163C8 $00
%patch $163E3 $00
%patch $1640B $00
%patch $16432 $00
%patch $16459 $00
%patch $1647E $00

%patch $1649E $00
%patch $164C6 $00
%patch $164EE $00
%patch $16516 $00

%patch $16542 $00
%patch $16570 $00

%end